#!/usr/bin/env chai
;;;; -*- mode: chai -*-

;; prelude.ch -- automatically run when chai starts
;; September 24, 2008
;;
;; Copyright (C) 2007-2008 Devin Papineau
;;
;; This software is provided 'as-is', without any express or implied
;; warranty.  In no event will the authors be held liable for any damages
;; arising from the use of this software.
;;
;; Permission is granted to anyone to use this software for any purpose,
;; including commercial applications, and to alter it and redistribute it
;; freely, subject to the following restrictions:
;;
;; 1. The origin of this software must not be misrepresented; you must not
;;    claim that you wrote the original software. If you use this software
;;    in a product, an acknowledgment in the product documentation would be
;;    appreciated but is not required.
;; 2. Altered source versions must be plainly marked as such, and must not be
;;    misrepresented as being the original software.
;; 3. This notice may not be removed or altered from any source distribution.
;;
;; Devin Papineau jdmpapin@uwaterloo.ca

;;; Execute code at compile time
defmacro: (oncompile: body) {
    ;; HACK: this isn't only a hack, it's a memory leak
    my throwaway_macro = gensym()

    [#progn,
      [#defmacro, [throwaway_macro],
        [#progn, body, [#quote, #nil]]],
      [throwaway_macro]]
}
;;; ----

let: files_to_load {
    load("_prelude_priv/_prelude_init")
    load("_prelude_priv/_prelude_init2")
    load("_prelude_priv/macros")
    load("_prelude_priv/List")
    load("_prelude_priv/Dict")
}
