#!/usr/bin/env chai
;; -*- mode: chai -*-

;; send_ops.ch -- semi handy-ish method call operators
;; October 1, 2008
;;
;; Copyright (C) 2007-2008 Devin Papineau
;;
;; This software is provided 'as-is', without any express or implied
;; warranty.  In no event will the authors be held liable for any damages
;; arising from the use of this software.
;;
;; Permission is granted to anyone to use this software for any purpose,
;; including commercial applications, and to alter it and redistribute it
;; freely, subject to the following restrictions:
;;
;; 1. The origin of this software must not be misrepresented; you must not
;;    claim that you wrote the original software. If you use this software
;;    in a product, an acknowledgment in the product documentation would be
;;    appreciated but is not required.
;; 2. Altered source versions must be plainly marked as such, and must not be
;;    misrepresented as being the original software.
;; 3. This notice may not be removed or altered from any source distribution.
;;
;; Devin Papineau jdmpapin@uwaterloo.ca

;; "And dot", like the "andand" ruby method.
defop: "&&.", "."

defmacro: (#|op_&&.:| tgt, msg) {
    ~~ (~.tgt &&. (~.msg)())
}

defcall: #|op_&&.|, f, args {
    my [tgt, msg] = f.slice(1, -1)
    my tmp = gensym()

    ~~ let: ~.tmp = ~.tgt {
        if: ~.tmp  { ~.tmp.(~.msg)(~*args) }
    }
}

;; "Dot?" like the "try" ruby method
defop: ".?", "."

defmacro: (#|op_.?:| tgt, msg) {
    ~~ (~.tgt.?(~.msg)())
}

defcall: #|op_.?|, f, args {
    my [tgt, msg] = f.slice(1,-1)
    my tmp = gensym()

    ~~ let: ~.tmp = ~.tgt {
        if: ~.tmp.responds_to?(quote: ~.msg) {
            ~.tmp.(~.msg)(~*args)
        }
    }
}
