/* Number.c -- common methods for number classes
   September 24, 2008

  Copyright (C) 2007-2008 Devin Papineau

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

  Devin Papineau jdmpapin@uwaterloo.ca
*/

#include "assorted.h"
#include "obj.h"
#include "value.h"
#include "sym_literals.h"

static ch_value_t num_pos(ch_value_t self)
{
    return self;
}

static ch_value_t num_neg(ch_value_t self)
{
    return CH_SEND(self, $t, ch_fix(-1)); //   *
}

void ch_defineNumberMethods()
{
    ch_defineMethod(ch_cNumber, SYM_unary$p, 0, (ch_cfn_t)num_pos); // unary+
    ch_defineMethod(ch_cNumber, SYM_unary$m, 0, (ch_cfn_t)num_neg); // unary-
}
