/* ch_signal.c -- chai signal handling interface
   September 24, 2008

  Copyright (C) 2007-2008 Devin Papineau

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

  Devin Papineau jdmpapin@uwaterloo.ca
*/

#ifndef CH_SIGNAL_H
#define CH_SIGNAL_H

#include <signal.h>

void ch_pushSignalHandlers(void);
void ch_popSignalHandlers(void);
void ch_handle_signal(int signal);
ch_value_t ch_signal_set_handler(int signal, ch_value_t handler);
int ch_signal_from_name(const char *name);

extern volatile sig_atomic_t ch_got_signal;
static inline void ch_check_signals(void)
{
    if (ch_got_signal) {
        int sig = ch_got_signal;
        ch_got_signal = 0;

        ch_handle_signal(sig);
    }
}

#endif /* CH_SIGNAL_H */
