/* compile.h -- chai lexer, parser, macroexpander, compiler interface
   September 24, 2008

  Copyright (C) 2007-2008 Devin Papineau

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

  Devin Papineau jdmpapin@uwaterloo.ca
*/

#ifndef COMPILE_H
#define COMPILE_H

#include "value.h"
#include "obj.h"
#include <stdio.h>

extern void ch_compiler_init();
extern void ch_defmacro_cfn(ch_value_t name, ch_cfn_t cfn);
extern void ch_defmacro(ch_value_t name, ch_value_t impl);
extern ch_value_t ch_compile_file(const char* filename);
extern ch_value_t ch_compile_stdio_file(FILE *fp);
extern ch_value_t ch_macroexpand(ch_value_t expression);
extern ch_value_t ch_evalString(const char *source);
extern ch_value_t ch_evalFile(const char *filename);
extern ch_value_t ch_load(const char *name);
extern ch_value_t ch_macroexpand1(ch_value_t);
extern ch_value_t ch_macroexpand(ch_value_t);
extern ch_value_t ch_defcalledp(ch_value_t);
extern ch_value_t ch_defsetfedp(ch_value_t);
extern ch_value_t ch_my_bindings_for(ch_value_t);

#endif /* COMPILE_H */
