#!/bin/sh

# uninstall.sh -- chai uninstall script
# September 30, 2008
#
# Copyright (C) 2007-2008 Devin Papineau
#
# This software is provided 'as-is', without any express or implied
# warranty.  In no event will the authors be held liable for any damages
# arising from the use of this software.
#
# Permission is granted to anyone to use this software for any purpose,
# including commercial applications, and to alter it and redistribute it
# freely, subject to the following restrictions:
#
# 1. The origin of this software must not be misrepresented; you must not
#    claim that you wrote the original software. If you use this software
#    in a product, an acknowledgment in the product documentation would be
#    appreciated but is not required.
# 2. Altered source versions must be plainly marked as such, and must not be
#    misrepresented as being the original software.
# 3. This notice may not be removed or altered from any source distribution.
#
# Devin Papineau jdmpapin@uwaterloo.ca

PREFIX="$1"
if [ "x$PREFIX" = x ]; then
    if [ -f .installed_prefix ]; then
        PREFIX=`cat .installed_prefix`
    else
        PREFIX=/usr/local
    fi
else
    shift
fi

cmd () {
    echo "$@"
    "$@"
}

if [ -d "$PREFIX/bin" ]; then
    cmd rm "$PREFIX/bin/chai"
    cmd rm "$PREFIX/bin/repl.ch"
fi

LIB_EXT="$(./lib_ext.sh)"

if [ -d "$PREFIX/lib" ]; then
    cmd rm "$PREFIX/lib/libchai$LIB_EXT"

    if [ -d "$PREFIX/lib/chai" ]; then
        cmd rm "$PREFIX/lib/chai/prelude.ch"
        cmd rm "$PREFIX/lib/chai/sourcify.ch"
        cmd rm "$PREFIX/lib/chai/iter.ch"
        cmd rm "$PREFIX/lib/chai/send_ops.ch"
        cmd rm "$PREFIX/lib/chai/math$LIB_EXT"
        cmd rm "$PREFIX/lib/chai/sys$LIB_EXT"

        if [ -d "$PREFIX/lib/chai/_prelude_priv" ]; then
            cmd rm "$PREFIX/lib/chai/_prelude_priv/Dict.ch"
            cmd rm "$PREFIX/lib/chai/_prelude_priv/List.ch"
            cmd rm "$PREFIX/lib/chai/_prelude_priv/_prelude_init.ch"
            cmd rm "$PREFIX/lib/chai/_prelude_priv/_prelude_init2.ch"
            cmd rm "$PREFIX/lib/chai/_prelude_priv/_prelude_iterable_extra.ch"
            cmd rm "$PREFIX/lib/chai/_prelude_priv/macros.ch"
            cmd rmdir "$PREFIX/lib/chai/_prelude_priv"
        fi

        cmd rmdir "$PREFIX/lib/chai"
    fi
fi

if [ -d "$PREFIX/include/chai" ]; then
    cmd rm "$PREFIX"/include/chai/*.h
    cmd rmdir "$PREFIX/include/chai"
fi
